#ifndef OnX_CallbackData_h
#define OnX_CallbackData_h 

#include <Slash/UI/ICallbackData.h>

namespace OnX {

class CallbackData : public virtual Slash::UI::ICallbackData {
public://Slash::UI::ICallbackData
  virtual Slash::UI::IWidget* widget() const;
  virtual std::string component() const;
  virtual std::string value() const;
  virtual std::string event() const;
  virtual int x() const;
  virtual int y() const;
  virtual bool copy(const ICallbackData&);
public:
  CallbackData();
  CallbackData(Slash::UI::IWidget*,
               const std::string&,
               const std::string&,
               const std::string&,
               int,int);
  CallbackData(const CallbackData&);
  virtual ~CallbackData();
  CallbackData& operator=(const CallbackData&);
private:
  Slash::UI::IWidget* fWidget;
  std::string fComponent;
  std::string fValue;
  std::string fEvent;
  int fX;
  int fY;
};

}

#endif
