#ifndef OnX_QtTools_h
#define OnX_QtTools_h 

#include <string>
#include <vector>

namespace Slash {namespace Core {class IWriter;}}

#include <qnamespace.h>

class QString;
class QWidget;
class QComboBox;
class QDialog;
class QTabWidget;

#if QT_VERSION < 0x040000
class QHBox;
class QVBox;
class QButton;
class QListViewItem;
#else
class QAbstractButton;
class OnX_Q3HBox;
class OnX_Q3VBox;
class QTreeWidget;
class QTreeWidgetItem;
#endif

namespace OnX {

Qt::WFlags decorationFlags(const std::vector< std::pair<bool,std::string> >&,
                           Slash::Core::IWriter&);
int QWidgetGetNumberOfChildren(QWidget&);
void QWidgetSetForeground(QWidget&,const std::string&);
void QWidgetSetBackground(QWidget&,const std::string&);

void QComboBoxSetBackground(QComboBox&,const std::string&);
void QComboBoxSetItems(QComboBox&,const std::vector<std::string>&);
std::vector<std::string> QComboBoxGetItems(QComboBox&);
void QComboBoxSetValue(QComboBox&,const std::string&);
std::string QComboBoxGetValue(QComboBox&);

void QOptionMenuInitialize(QComboBox&,const std::vector<std::string>&,const std::string&);
std::vector<std::string> QOptionMenuGetItems(QComboBox&);
bool QOptionMenuSetDefault(QComboBox&,const std::string&);
std::string QOptionMenuGetValue(QComboBox&);

#if QT_VERSION < 0x040000
void QButtonSetBackground(QButton&,const std::string&);
bool QHBoxSetExpand(QHBox&,const std::string&);
bool QVBoxSetExpand(QVBox&,const std::string&);
std::string QListViewItemGetPath(QListViewItem*);
std::string QListViewItemGetXML(QListViewItem*);
#else
void QButtonSetBackground(QAbstractButton&,const std::string&);
bool QHBoxSetExpand(OnX_Q3HBox&,const std::string&);
bool QVBoxSetExpand(OnX_Q3VBox&,const std::string&);
std::string QTreeWidgetItemGetPath(QTreeWidgetItem&);
std::string QTreeWidgetItemGetXML(QTreeWidgetItem&);
#endif


void QDialogDisableEnter(QDialog&);

bool QTabWidgetSetSelection(QTabWidget&,const std::string&);

}

#if QT_VERSION < 0x040000
#else
#undef QHBox
#undef QVBox
#undef QListViewItem
#endif

#endif

